
```ucm
.> builtins.merge

  Done.

```
```unison
-- List.map : (a -> b) -> [a] -> [b]
List.map f =
  go acc = cases
    [] -> acc
    h +: t -> go (acc :+ f h) t
  go []
```

```ucm

  I found and typechecked these definitions in scratch.u. If you
  do an `add` or `update`, here's how your codebase would
  change:
  
    ⍟ These new definitions are ok to `add`:
    
      List.map : (i ->{g} o) ->{g} [i] ->{g} [o]

```
```ucm
.> add

  ⍟ I've added these definitions:
  
    List.map : (i ->{g} o) ->{g} [i] ->{g} [o]

.> view List.map

  List.map : (i ->{g} o) ->{g} [i] ->{g} [o]
  List.map f =
    go acc = cases
      []     -> acc
      h +: t -> go (acc :+ f h) t
    go []

```
```unison
List.map2 : (g -> g2) -> [g] -> [g2]
List.map2 f =
  unused = "just to give this a different hash"
  go acc = cases
    [] -> acc
    h +: t -> go (acc :+ f h) t
  go []
```

```ucm

  I found and typechecked these definitions in scratch.u. If you
  do an `add` or `update`, here's how your codebase would
  change:
  
    ⍟ These new definitions are ok to `add`:
    
      List.map2 : (g ->{h} g2) ->{h} [g] ->{h} [g2]

```
